<script setup>
import { computed, defineAsyncComponent } from 'vue';
import { } from '../itemsBase';
import InfoBlock from './info-block.vue';
import game from '../../game';
import Summon from './summon.vue';
import { getHealing, displayHealing } from './healingMixin.js';
import { useDamage } from './use-damage';
const Attack = defineAsyncComponent(() => import('./attack'));

//const GData = defineAsyncComponent(() => import( './gdata.vue'));

/**
 * This is the dot InfoBlock in an info-popup, not the dotView in window.
 */

const props = defineProps(['dot', 'title', 'item', 'target']);
const { getDamage, displayDamage } = useDamage();

///name: 'dot',

const healing = computed(() => {
	return getHealing(props.dot);
});
const damage = computed(() => {
	return getDamage(props.dot);
});
const name = computed(() => {
	return props.dot.name || props.dot.id || props.item?.name;
});
const potency = computed(() => {

	if (!props.dot.potencies) return "";
	let potencystring = ""


	for (const a of props.dot.potencies) {
		if (potencystring != "") potencystring = potencystring.concat(", ");
		potencystring = potencystring.concat(game.state.getData(a).name.replace(" damage", "").toTitleCase())
	}
	return potencystring
});
</script>

<template>
	<div class="dot">
		<div v-if="title" class="note-text">{{ title }}:</div>

		<div v-if="Array.isArray(dot)">
			<div v-for="(dots, idx) in dot" :key="'dot-' + idx">
				<div v-if="idx !== 0" class="info-sect"></div>
				<DotInfo :dot="dots" :item="item" :target="target" />
			</div>
		</div>
		<div v-else>
			<div v-if="name && item?.name !== name">
				<span>Name: </span><span>{{ name.toString().toTitleCase() }}</span>
			</div>
			<div>
				<div v-if="!dot.damage && !dot.dmg && !dot.effect && !dot.mod && name !== dot.id">
					<div v-if="dot.id">Id: {{ dot.id.toString().toTitleCase() }}</div>
				</div>
			</div>
			<div>
				<div v-if="displayDamage(dot)">
					<span>Estimated damage: </span><span>{{ damage }}</span>
					<div v-if="dot.potencies">Damage scaling: {{ potency }}</div>
				</div>
				<div v-if="displayHealing(dot)">
					<span>Estimated healing: </span><span>{{ healing }}</span>
					<div v-if="dot.potencies">Heal scaling: {{ potency }}</div>
				</div>
				<div v-if="dot.kind">Kind: {{ dot.kind.toString().toTitleCase() }}</div>
				<div v-if="dot.duration">Duration: {{ dot.duration + "s" || 'infinity' }}</div>
			</div>

			<div v-if="dot.effect">
				<div class="info-sect">Effects</div>
				<InfoBlock :info="dot.effect" rate="true" />
			</div>
			<div v-if="dot.summon">
				<div class="info-sect">Summons</div>
				<Summon :item="dot" class="info-subsubsect" />
			</div>
			<div v-if="dot.mod">
				<div class="info-sect">Modifications</div>
				<InfoBlock :info="dot.mod" :target="target" />
			</div>
			<div v-if="dot.attack">
				<div class="info-sect">Attack</div>
				<Attack :item="dot" class="info-subsubsect" />
			</div>
			<div v-if="dot.onExpire">
				<div class="info-sect">On expiration</div>
				<Attack :item="dot" onexpireflag = "true" class="info-subsubsect" />
			</div>
			<div v-if="dot.onDeath">
				<div class="info-sect">When target killed</div>
				<Attack :item="dot" ondeathflag = "true" class="info-subsubsect" />
			</div>
		</div>
	</div>
</template>